#include <stdio.h>
#include <fcntl.h>

int main()
{
char c;
int fd=open("/root/x",O_RDONLY);
int count;
if(fd==-1)
	{fprintf(stderr,"Il file /root/x non esiste .\n");exit(1);}
for(lseek(fd,0,2);c!='7';count=lseek(fd,-2,1))//NOTA_1
	read(fd,&c,1);
printf("Obiettivo: fermarsi al primo '7' partendo "
       "dalla fine del file\n");
printf("Ultimo Carattere Letto: %c\nPosizione ritornata da lseek: %d\n"
	,c,count);
}

/*NOTA_1
lseek() ritorna la posizione in cui il descrittore e' fermo ,-1 se si
verifica qualche errore .
Il numero che ritorna (nel nostro esempio) puo' sembrare sbagliato 
(teniamo conto che conta in base 0 quindi il 1o carattere ha n 0) ma
se effettivamente effettuiamo un'altra chiamata a read() di 1
carattere notiamo che il df era fermo proprio sul "i"esimo carattere
ritornato da lseek .
Cio' perche' quando effettuiamo una read od una write su un 
descrittore di file ,il carattere/i viene scritto ma fd punta alla
posizione seguente (analogamente a getc() e putc()) .
Il ciclo for fa cominciare lo scanning del file dalla fine (se
cio' non avessimo fatto non ci sarebbe stato d'aiuto lseek()) e 
termina quando "c" vale '7' : si sposta alla fine del file ,legge
un carattere (anche se per aumentare la velocita' sarebbe stato meglio
bufferizzare) ,si sposta indietro di 2 byte (perche' dopo 1a read o 
write fd punta al carattere dopo) e viene rivaluta la condizione del 
ciclo .
Come parametri accetta : 
1o un descrittore di files (int)
2o l'offset ,ossia il numero degli spostamenti che deve 
   effettuare (-n o +n a seconda se prima o dopo il punto in cui si e')
3o l'origina da cui partire 0 - inizio file
			    1 - posizione corrente
			    2 - fine file*/
