#include <stdio.h>
#define nclean() for(;getchar()!='\n';);
int main()
{
int n,*p;
printf("[ CALLOC ]\ndigitare il numero degli oggetti del vettore : ");
scanf("%d",&n);nclean();
if(!(p=(int*)calloc(n,sizeof(int))))
	{fprintf(stderr,"non c'e' abbastanza memoria .\n");exit(1);}//NOTA_1
printf("CALLOC: allocato un vettore di %d elementi ognuno di %d bytes\n",n,sizeof(int));
for(;n--;*p++=7);//NOTA_2
free(p);//NOTA_3

printf("[ MALLOC ]\ndigitare i bytes di memoria da allocare : ");
scanf("%d",&n);
if(!(p=(int*)malloc(n)))//NOTA_4
	{fprintf(stderr,"non c'e' abbastanza memoria .\n");exit(2);}
printf("MALLOC: allocato un vettore di %d elementi\n",n);
for(/*n/=4*/n/=sizeof(int);n;*p++=7)//NOTA_7//NOTA_5
	--n;
free(p);
//NOTA_6
}

/*NOTA_1
calloc : il suo primo argomento e' il numero degli oggetti che devono comporre il vettore
	 il secondo e' la dimensione che ogni singolo oggetto del vettore deve avere
se la memoria richiesta e' disponibile restituisce un void* che dev'essere forzato per 
poter essere utilizzato ,NULL altrimenti .
c=(char*)calloc(n,sizeof(char));
NOTA_2
accedo alla memoria allocata
NOTA_3
free(void*) accetta come argomento un puntatore ottenuto con una chiamata a malloc&c .
Libera (rilascia) la memoria puntata .
rilascio la memoria che non mi serve piu' .
Se non facessi cio' quell'area di memoria verrebbe considerata occupata dal buffer
comune alle funzioni di questo tipo .
NOTA_4
malloc : il 1o arg (e l'unico) e' la dimensione ,in bytes ,del blocco di memoria da allocare
	 malloc ritorna ,se non si verificano errori ,un void* al primo oggetto della memoria
	 allocata; NULL altrimenti .
Importante : se il blocco allocato e' di 16 bytes non posso memorizzare piu' di 4 int (sulla
	     mia macchina 1 int e' 4 bytes)
NOTA_5
accedo alla memoria allocata ,quindi ,la rilascio con free(p).
NOTA_6
la differenza che c'e' dta calloc e malloc e' che mentre malloc alloca dinamicamente
memoria servendosi della sola ampiezza del vettore da allocare ,calloc richiede anche
la dimensione che deve assumere ogni oggetto facente parte di esso .
NOTA_7
non e' detto che su tutte le macchine un int sia 4 bytes . Ho preferito optare per una
soluzione piu' protabile che valga per tutte le piattaforme .*/
