#include<stdio.h>
#include<fcntl.h>
#define BUFSIZE 10000
int main()
{
char s[BUFSIZE];//NOTA_1
int fd1=open("/root/x",O_RDONLY),fd2,count;
if((fd2=creat("/root/y",0))==-1)//NOTA_2
	{fprintf(stderr,"Impossibile creare il file\n");exit(1);}
for(;(count=read(fd1,s,BUFSIZE))!=0;write(fd2,s,count));//NOTA_3
close(fd1);
close(fd2);
}

/*NOTA_1
potevo usare malloc ma l'allocazione dinamica della memoria qui e'
perfettamente inutile .
NOTA_2
creat is equivalent to `open' with `flags' equal to
O_CREAT|O_WRONLY|O_TRUNC .
In pratica creat() e' un alias di vari flag di open collegati .
Come open() (essendo 1 derivato) se si verificano errori la
funzione ritorna -1 .
NOTA_3
operare a basso livello ci consente di utilizzare semplicemente una
primitiva forma di buffering : vengono letti blocchi di BUFSIZE
elementi alla volta che poi vengono scritti sempre in un unico 
accesso .
Cio' riduce l'accesso al disco e i tempi d'attesa .
Ad alto livello con la setvbuf() non sono riuscito ad ottenere
un minimo miglioramento delle prestazioni per ora : il metodo
da adottare sarebbe copiare n elementi da file di origine e
scriverli nel file destinazione ..ma il codice risulterebbe
molto piu' lungo rispetto a quello che opera a basso livello .
Un po' di tempi : sul mio hd   alto livello copio 20Mb in 21s~
			       basso livello copio 20Mb in 2s~*/
