#include<stdio.h>
#include<sys/stat.h>//NOTA_1
//#include<sys/types.h>//NOTA_2
int main(int argc,char*argv[])
{
int i=0;
struct stat prima;//NOTA_3
if(argc==1)
	{printf("Directory .\n");exit(0);}
else	for(--argc;i++<argc;)
	 	{if(stat(argv[i],&prima)==-1)//NOTA_4
	 	       {fprintf(stderr,"Accesso negato a %s\n",argv[i]);
	 	        continue;}
 	 	 printf("%s = %s\n",argv[i],(prima.st_mode&S_IFMT)==S_IFDIR?//NOTA_5
 	 	 	"Directory":"File");}
}

/*NOTA_1
la struttura che permette di memorizzare cio' che stat() ritorna .
sys/stat.h contiene anche la definizione di particolari flag come
quelli usati .
NOTA_2
Non sono usati da questo programma ma definisce i tipi come dev_t ed
ino_t (dei tipi dichiarati nelle strutture stat) .
NOTA_3
dichiaro una struttura stat prima che conterra' i dati ritornati
da stat()
NOTA_4
stat() 1o arg un char* contenente il pathname del file/directory
       2o arg l'indirizzo di una struttura stat che conterra' i dati
       	ritornati .
       se ha successo ritortna 0 ,-1 altrimenti .
NOTA_5
S_IFMT		tipo del file:
S_IFDIR		directory
S_IFCHR		speciale a caratteri
S_IFBLK		speciale a blocchi
S_IFREG		regolare
sono dei flag definiti in sys/stat.h che otteniamo accedendo al
campo st_mode della struttura stat ritornata .
Facendo un and logico con S_IFMT otteniamo il flag che descrive
il file (quindi uno dei 4 rimanenti) .
Nella riga 14 prima.st_mode viene & ad S_IFMT ,quest'operazione
dara' luogo al ritorno di uno dei 4 flag . Ne nostro caso ,SE e'
uguale a S_IFDIR ...*/
